%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                         PSG Type    PSG Object           Location in Problem Statement                      Class
%matrix_returns_data            data        matrix_returns       linear(matrix_returns)                             double
%matrix_returns_vars            vars        matrix_returns       linear(matrix_returns)                             cell
%matrix_scenario_probability    prob        matrix_scenario      var_risk(parameter_alpha, matrix_scenario)         double
%matrix_scenario_data           data        matrix_scenario      var_risk(parameter_alpha, matrix_scenario)         double
%matrix_scenario_vars           vars        matrix_scenario      var_risk(parameter_alpha, matrix_scenario)         cell
%point_lowerbounds_data         data        point_lowerbounds    Box: >= point_lowerbounds, <= point_upperbounds    double
%point_lowerbounds_vars         vars        point_lowerbounds    Box: >= point_lowerbounds, <= point_upperbounds    cell
%point_upperbounds_data         data        point_upperbounds    Box: >= point_lowerbounds, <= point_upperbounds    double
%point_upperbounds_vars         vars        point_upperbounds    Box: >= point_lowerbounds, <= point_upperbounds    cell
%parameter_alpha_data           data        parameter_alpha      var_risk(parameter_alpha, matrix_scenario)         double
%parameter_bound_data           data        parameter_bound      Constraint: >= parameter_bound                     double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_returns_data,matrix_returns_vars,matrix_scenario_probability,matrix_scenario_data,matrix_scenario_vars,point_lowerbounds_data,point_lowerbounds_vars,point_upperbounds_data,point_upperbounds_vars,parameter_alpha_data,parameter_bound_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_returns',matrix_returns_data,matrix_returns_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_scenario',matrix_scenario_data,matrix_scenario_vars,[],matrix_scenario_probability);
count = count+1;
iargstruc_arr(count) = point_pack('point_lowerbounds',point_lowerbounds_data,point_lowerbounds_vars);
count = count+1;
iargstruc_arr(count) = point_pack('point_upperbounds',point_upperbounds_data,point_upperbounds_vars);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'  var_risk(parameter_alpha, matrix_scenario)',...
'Constraint: >= parameter_bound',...
'  linear(matrix_returns)',...
'Box: >= point_lowerbounds, <= point_upperbounds',...
'',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_alpha',num2str(parameter_alpha_data));
problem_statement = strrep(problem_statement,'parameter_bound',num2str(parameter_bound_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

