%This Example for using users m-function Optimization_subroutine.m was created automatically by PSG Toolbox.

%Function description:

%minimize
%var_risk(parameter_alpha, matrix_scenario)
%Constraint: >= parameter_bound
%linear(matrix_returns)
%Box: >= point_lowerbounds, <= point_upperbounds
%
%
%Input variables:
%
%Inputs                         PSG Type    PSG Object           Location in Problem Statement                      Class
%matrix_returns_data            data        matrix_returns       linear(matrix_returns)                             double
%matrix_returns_vars            vars        matrix_returns       linear(matrix_returns)                             cell
%matrix_scenario_probability    prob        matrix_scenario      var_risk(parameter_alpha, matrix_scenario)         double
%matrix_scenario_data           data        matrix_scenario      var_risk(parameter_alpha, matrix_scenario)         double
%matrix_scenario_vars           vars        matrix_scenario      var_risk(parameter_alpha, matrix_scenario)         cell
%point_lowerbounds_data         data        point_lowerbounds    Box: >= point_lowerbounds, <= point_upperbounds    double
%point_lowerbounds_vars         vars        point_lowerbounds    Box: >= point_lowerbounds, <= point_upperbounds    cell
%point_upperbounds_data         data        point_upperbounds    Box: >= point_lowerbounds, <= point_upperbounds    double
%point_upperbounds_vars         vars        point_upperbounds    Box: >= point_lowerbounds, <= point_upperbounds    cell
%parameter_alpha_data           data        parameter_alpha      var_risk(parameter_alpha, matrix_scenario)         double
%parameter_bound_data           data        parameter_bound      Constraint: >= parameter_bound                     double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


%Load data from mat-file:
load('D:\American Optimal Decisions\PSG\MATLAB_Stan\All\VaR vs Difference of CVaRs Minimization\problem_1_10000_VaR_0p95\Optimization_subroutine_data.mat')

%Save variables from mat-file to Workspace:
tbpsg_export_to_workspace(toolboxstruc_arr)

%Run users m-function Optimization_subroutine:

[solution_str,outargstruc_arr] = Optimization_subroutine(matrix_returns_data,matrix_returns_vars,matrix_scenario_probability,matrix_scenario_data,matrix_scenario_vars,point_lowerbounds_data,point_lowerbounds_vars,point_upperbounds_data,point_upperbounds_vars,parameter_alpha_data,parameter_bound_data);

%Extract Objective:
val_obj = tbpsg_objective(solution_str, outargstruc_arr);

disp(' ');
disp('Objective = ');
disp(val_obj);

%Extract optimal solution:
point_data = tbpsg_optimal_point_data(solution_str, outargstruc_arr);

disp(' ');
disp('Optimal point = ');
disp(point_data);

%Extract structure containing PSG solution reports:
output_structure = tbpsg_solution_struct(solution_str, outargstruc_arr);

disp(' ');
disp('Structure with PSG solution = ');
disp(output_structure);

%Uncomment the following lines to extract solutions details:

%output = tbpsg_isoptimal(solution_str, outargstruc_arr);

%output = tbpsg_function_data(solution_str, outargstruc_arr);

%output = tbpsg_function_names(solution_str, outargstruc_arr);

%output = tbpsg_time(solution_str, outargstruc_arr);

%output = tbpsg_optimal_point_vars(solution_str, outargstruc_arr);

%output = tbpsg_constraints_vars(solution_str, outargstruc_arr);

%output = tbpsg_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_constraint_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_vars(solution_str, outargstruc_arr);

%output = tbpsg_vector_data(solution_str, outargstruc_arr);

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 
